# == Class prometheusforemansd::service
#
# This class is meant to be called from prometheusforemansd
# It ensure the service is running
#
class prometheusforemansd::service {
  case $::prometheusforemansd::install_method {
    'archive': {
      $service_path   = "${::prometheusforemansd::install_dir}/prometheus-foreman-sd"
      $service_config = "${::prometheusforemansd::install_dir}/prometheusforemansd.yaml"

      if !defined(Service[$::prometheusforemansd::service_name]){
        service { $::prometheusforemansd::service_name:
          ensure     => running,
          provider   => base,
          binary     => "su - root -c '${service_path} service --config=${service_config} &'",
          stop       => "ps -ef | grep prometheus-foreman-sd | grep -v grep | awk '{print \$2}' | xargs -r kill -9",
          hasrestart => false,
          hasstatus  => false,
          status     => "ps -ef | grep prometheus-foreman-sd | grep -v grep"
        }
      }
    }
    default: {
      fail("Installation method ${::prometheusforemansd::install_method} not supported")
    }
  }
}